﻿<?xml version="1.0" encoding="utf-8" ?>
<ContentPage xmlns="http://xamarin.com/schemas/2014/forms"
             xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"
             x:Class="SHControl.Views.HistoryPage"
             xmlns:beh="clr-namespace:SHControl.Behavior"
             xmlns:v="clr-namespace:SHControl.Views"
             xmlns:sel="clr-namespace:SHControl.TemplateSelectors"
             xmlns:conv="clr-namespace:SHControl.Converters" Title="{Binding Title}">
    <!--Страница истории-->
    <ContentPage.Resources>
        <!--Преобразователь DateTime в форматированную строку-->
        <conv:DateToStringConverter x:Key="DateToStringConverter"></conv:DateToStringConverter>
    </ContentPage.Resources>
    <ContentPage.Behaviors>
        <!--Преобразование событий появления и исчезновения страницы-->
        <beh:EventToCommandBehavior Command="{Binding AppearingCommand}" EventName="Appearing" />
        <beh:EventToCommandBehavior Command="{Binding DisappearingCommand}" EventName="Disappearing" />
    </ContentPage.Behaviors>
    <ContentPage.Content>
        <!--ListView с историей-->
        <Grid RowSpacing="0" Margin="0" Padding="0">
            <Grid.RowDefinitions>
                <RowDefinition Height="10*"></RowDefinition>
                <RowDefinition Height="90*"></RowDefinition>
            </Grid.RowDefinitions>
            <Grid Grid.Row="0" Padding="0" RowSpacing="0" Margin="0" BackgroundColor="Yellow">
                <Grid.RowDefinitions>
                    <RowDefinition Height="3*"></RowDefinition>
                    <RowDefinition Height="94*"></RowDefinition>
                    <RowDefinition Height="3*"></RowDefinition>
                </Grid.RowDefinitions>
                <Grid Grid.Row="0" BackgroundColor="Black"></Grid>
                <Grid Grid.Row="2" BackgroundColor="Black"></Grid>
                <Grid Grid.Row="1" RowSpacing="0" Margin="0">
                    <Grid.ColumnDefinitions>                        
                        <ColumnDefinition Width="20*"></ColumnDefinition>
                        <ColumnDefinition Width="0.5*"></ColumnDefinition>
                        <ColumnDefinition Width="40*"></ColumnDefinition>
                        <ColumnDefinition Width="0.5*"></ColumnDefinition>
                        <ColumnDefinition Width="40*"></ColumnDefinition>                        
                    </Grid.ColumnDefinitions>                    
                    <Grid Grid.Column="1" BackgroundColor="Black"></Grid>
                    <Grid Grid.Column="3" BackgroundColor="Black"></Grid>                    
                    <Label Grid.Column="0" Text="Дата/Время" HorizontalTextAlignment="Center" VerticalTextAlignment="Center">
                        <Label.GestureRecognizers>
                            <TapGestureRecognizer Command="{Binding TimeSortCommand}"></TapGestureRecognizer>
                        </Label.GestureRecognizers>
                    </Label>
                    <Label Grid.Column="2" Text="Действие" HorizontalTextAlignment="Center" VerticalTextAlignment="Center">
                        <Label.GestureRecognizers>
                            <TapGestureRecognizer Command="{Binding ActionSortCommand}"></TapGestureRecognizer>
                        </Label.GestureRecognizers>
                    </Label>
                    <Label Grid.Column="4" Text="Значение" HorizontalTextAlignment="Center" VerticalTextAlignment="Center"></Label>
                </Grid>
                
            </Grid>
            <Grid Grid.Row="1" Padding="0" RowSpacing="0" Margin="0">
                <ListView 
                    HasUnevenRows="True"
                    ItemsSource="{Binding HData, Mode=OneWay}"
                    CachingStrategy="RecycleElement"
                    IsPullToRefreshEnabled="False"
                    SeparatorColor="Red"
                    SeparatorVisibility="Default">
                    <ListView.ItemTemplate>
                        <DataTemplate>
                            <ViewCell>
                                <Grid>
                                    <Grid.GestureRecognizers>
                                        <TapGestureRecognizer></TapGestureRecognizer>
                                    </Grid.GestureRecognizers>
                                    <Grid.ColumnDefinitions>                                        
                                        <ColumnDefinition Width="20*"></ColumnDefinition>
                                        <ColumnDefinition Width="0.5*"></ColumnDefinition>
                                        <ColumnDefinition Width="40*"></ColumnDefinition>
                                        <ColumnDefinition Width="0.5*"></ColumnDefinition>
                                        <ColumnDefinition Width="40*"></ColumnDefinition>                                        
                                    </Grid.ColumnDefinitions>                                    
                                    <Grid Grid.Column="1" BackgroundColor="Black"></Grid>
                                    <Grid Grid.Column="3" BackgroundColor="Black"></Grid>                    
                                    <Label Grid.Column="0" Text="{Binding Date,Converter={StaticResource DateToStringConverter}}"></Label>
                                    <Label Grid.Column="2" Text="{Binding ActionDescr}"></Label>
                                    <Label Grid.Column="4" Text="{Binding AdditionalInfo}"></Label>

                                </Grid>
                            </ViewCell>
                            
                        </DataTemplate>
                    </ListView.ItemTemplate>
                </ListView>
            </Grid>
        </Grid>
    </ContentPage.Content>
</ContentPage>